/* aln1r2.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int aln1r2_c(real *a, real *b, real *cos__, real *sin__,
        real *sig)
{
    /* Initialized data */

    static real one = 1.f;
    static real zero = 0.f;

    /* System generated locals */
    real r__1;

    /* Builtin functions */
    double sqrt(doublereal), r_sign(real *, real *);

    /* Local variables */
    static real xr, yr;


/* ********************************************************* */

/*    PURPOSE: */
/*    CALCULATION OF ORTHOGONAL ROTATON MATRIX OF GIVENS. */

/*    METHOD: */
/*       FOR GIVEN 2-VECTOR  ( A ) WE */
/*                           ( B ) */

/*       COMPUTE MATRIX  G = (  COS , SIN  ) SO THAT */
/*                           ( -SIN , COS  ) */

/*     (  COS     SIN ) ( A ) = ( SQRT(A**2+B**2) ) */
/*     ( -SIN     COS ) ( B ) = ( 0               ). */

/*   COMPUTE SIG = SQRT(A**2+B**2). */
/*   SIG IS COMPUTED LAST TO ALLOW FOR THE POSSIBILITY */
/*   THAT SIG MAY BE IN THE SAME LOCATION AS A OR B. */
/*   SUBROUTINE ALN1R2 IS MODIFICATION OF G1 FROM [1]. */

/*    REFERENCES: */
/*    1.LAWSON C.L. AND HANSON R.J. SOLVING LEAST SQUARES */
/*    PROBLEMS.- PRENTICE-HALL,INC.,ENGLEWOOD CLIFFS,NEW */
/*    JERSEY,1974. */

/*   USAGE: */
/*       CALL ALN1R2(A,B,COS,SIN,SIG) */

/*     INPUT PARAMETERS: */
/*  A - REAL VARIABLE- THE FIRST COMPONENT OF VECTOR; */
/*  B - REAL VARIABLE - THE SECOND COMPONENT OF VECTOR */

/*     OUTPUT PARAMETERS: */
/*  COS -REAL VARIABLE-THE FIRST ELEMENT OF GIVENS MATRIX; */
/*  SIN -REAL VARIABLE-THE SECOND ELEMENT OF GIVENS MATRIX */
/*  SIG -REAL VARIABLE-THE EVALUATED NORM OF 2-VECTOR */
/*       (A,B). */

/*     STANDARD FUNCTIONS AND PROCEDURES: ABS , SQRT . */

/* ********************************************************* */


/*      SEARCH OF A MAXIMAL COMPONENT OF ( A , B ). */

    if (abs(*a) <= abs(*b)) {
        goto L10;
    }

/*    A  IS A MAXIMAL COMPONENT. */
/*    NORMALIZATION TO PREVENT THE OVERFLOW OR UNDERFLOW. */

    xr = *b / *a;
/* Computing 2nd power */
    r__1 = xr;
    yr = (real)sqrt(one + r__1 * r__1);
    r__1 = one / yr;
    *cos__ = (real)r_sign(&r__1, a);
    *sin__ = *cos__ * xr;
    *sig = abs(*a) * yr;
    goto L40;

/*       CHECK OF NONZERO VALUE OF  B . */

L10:
    if (*b != 0.f) {
        goto L20;
    } else {
        goto L30;
    }

/*    B  IS THE MAXIMAL COMPONENT. */
/*    NORMALIZATION FOR PREVENT THE OVERFLOW OR UNDERFLOW. */

L20:
    xr = *a / *b;
/* Computing 2nd power */
    r__1 = xr;
    yr = (real)sqrt(one + r__1 * r__1);
    r__1 = one / yr;
    *sin__ = (real)r_sign(&r__1, b);
    *cos__ = *sin__ * xr;
    *sig = abs(*b) * yr;
    goto L40;

/*        BOTH  A  AND  B  ARE ZERO'S. */

L30:
    *sig = zero;
    *cos__ = zero;
    *sin__ = one;

/*       END OF CALCULATION OF GIVENS ROTATION MATRIX. */

L40:
    return 0;
} /* aln1r2_c */
