/* aln1r3.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int aln1r3_c(real *cos__, real *sin__, real *x, real *y)
{
    static real xr;

/* ********************************************************* */

/*    PURPOSE: */
/*       APPLICATION OF GIVENS ORTHOGONAL ROTATION MATRIX. */

/*    METHOD: */
/*       FOR GIVEN 2-VECTOR  ( X ) */
/*                           ( Y ) */
/*       ROTATION COMPUTED BY ALN1R2 IS APPLIED. */
/*       THE ROTATION MATRIX */

/*               ( COS     SIN ) */
/*               (-SIN     COS ) */

/*       IS GIVEN BY ITS ELEMENTS  COS , SIN . */
/*       A RESULTS ARE PLACED AT THE SAME POSITIONS */
/*       IN MEMORY AS  X   AND  Y . */

/*    REFERENCES: */
/*    1.LAWSON C.L. AND HANSON R.J. SOLVING LEAST SQUARES */
/*      PROBLEMS.- PRENTICE-HALL,INC.,ENGLEWOOD CLIFFS,NEW */
/*      JERSEY,1974. */

/*    USAGE: */
/*       CALL ALN1R3 (COS,SIN,X,Y) */

/*    INPUT PARAMETERS: */
/*       COS - REAL VARIABLE - THE FIRST ELEMENT */
/*             OF GIVENS MATRIX; */
/*       SIN - REAL VARIABLE-THE SECOND ELEMENT */
/*             OF GIVENS MATRIX */

/*    INPUT AND OUTPUT PARAMETERS: */
/*       X - REAL VARIABLE -  ON ENTRANCE CONTAINS THE */
/*           FIRST COMPONENT OF 2-VECTOR; ON EXIT IT */
/*           CONTAINS THE FIRST COMPONENT OF TRANSFORMED */
/*           VECTOR; */
/*       Y - REAL VARIABLE - ON ENTRANCE CONTAINS THE */
/*           SECOND COMPONENT OF 2-VECTOR; ON EXIT IT */
/*           CONTAINS THE SECOND COMPONENT OF TRANSFORMED */
/*           VECTOR. */

/* ********************************************************* */
    xr = *cos__ * *x + *sin__ * *y;
    *y = -(*sin__) * *x + *cos__ * *y;
    *x = xr;
    return 0;
} /* aln1r3_c */
